package com.akamai.hdcore.samples.hdn1
{
	import com.akamai.hd.HDNetStream;
	import com.akamai.hdcore.samples.utility.HDN1MediaPlayerViewPresenter;
	import com.akamai.hdcore.samples.utility.MediaPlayerView;
	
	import flash.display.StageDisplayState;
	import flash.events.FullScreenEvent;
	import flash.net.NetConnection;
	
	import org.openvideoplayer.components.ui.shared.event.ControlEvent;
	
	/**
	 * This is a basic presenter class that allows you to override and enhance functionality
	 * within the HDN1MediaPlayerViewPresenter.as class located in the HDCoreSamplesUtility 
	 * project. 
	 * 
	 */
	public class MaxBitrateAllowedSamplePresenter extends HDN1MediaPlayerViewPresenter
	{		
		private static const MAX_BITRATE_FOR_NORMAL_PLAYBACK:int = 1500;
		
		public function MaxBitrateAllowedSamplePresenter(view:MediaPlayerView, netStream:HDNetStream, netConnection:NetConnection)
		{			
			super(view, netStream, netConnection, true/*set to false to hide the buffer metrics*/);
			netStream.loop = false;
			view.stage.addEventListener(FullScreenEvent.FULL_SCREEN, onStageFullScreen);
		}
		
		override public function destroy():void 
		{
			view.stage.removeEventListener(FullScreenEvent.FULL_SCREEN, onStageFullScreen);
		}		
		
		override protected function onStageFullScreen(event:FullScreenEvent):void
		{
			super.onStageFullScreen(event)
			if (view.stage.displayState == StageDisplayState.FULL_SCREEN)
			{
				HDNetStream(netStream).maximumBitrateAllowed = MAX_BITRATE_FOR_NORMAL_PLAYBACK;
			}
		}
		
		override protected function onPlayClick(event:ControlEvent=null):void
		{
			HDNetStream(netStream).maximumBitrateAllowed = MAX_BITRATE_FOR_NORMAL_PLAYBACK;
			super.onPlayClick(event);
		}
		
		override protected function onFullscreenClick(event:ControlEvent):void
		{
			if (view.stage.displayState == StageDisplayState.NORMAL)
			{
				HDNetStream(netStream).maximumBitrateAllowed = int.MAX_VALUE;
			}
			
			super.onFullscreenClick(event);
		}

	}
}
